
#ifndef LUBISHEV_EXCEPTION_H
#define LUBISHEV_EXCEPTION_H

#include <QString>
#include <QtGlobal>
#include <stdexcept>

namespace lubishev {

class Exception : public std::exception {
    public:
        Exception(const QString &type,
                  const QString &desc,
                  const QString &src,
                  const QString &file,
                  int line);
        ~Exception() throw() { };

        QString getDesc() const;
        QString getType() const;
        const char* what() const throw();

    private:
        QString mMsg;
        QString mType;
        QString mDesc;
};

} // namespace lubishev

#define LUBISHEV_EXCEPTION(TYPE, DESC) \
    throw lubishev::Exception(TYPE, DESC, __PRETTY_FUNCTION__, __FILE__, __LINE__);

#endif // LUBISHEV_EXCEPTION_H

